e7a346
From 03e4bab925b20832492c9954d3ecb6c10fe56548 Mon Sep 17 00:00:00 2001
e7a346
From: Ravishankar N <ravishankar@redhat.com>
e7a346
Date: Wed, 10 Oct 2018 17:57:33 +0530
e7a346
Subject: [PATCH 403/404] afr: prevent winding inodelks twice for arbiter
e7a346
 volumes
e7a346
e7a346
Backport of https://review.gluster.org/#/c/glusterfs/+/21380/
e7a346
e7a346
Problem:
e7a346
In an arbiter volume, if there is a pending data heal of a file only on
e7a346
arbiter brick, self-heal takes inodelks twice due to a code-bug but unlocks
e7a346
it only once, leaving behind a stale lock on the brick. This causes
e7a346
the next write to the file to hang.
e7a346
e7a346
Fix:
e7a346
Fix the code-bug to take lock only once. This bug was introduced master
e7a346
with commit eb472d82a083883335bc494b87ea175ac43471ff
e7a346
e7a346
Thanks to  Pranith Kumar K <pkarampu@redhat.com> for finding the RCA.
e7a346
e7a346
Change-Id: I15ad969e10a6a3c4bd255e2948b6be6dcddc61e1
e7a346
BUG: 1636902
e7a346
Signed-off-by: Ravishankar N <ravishankar@redhat.com>
e7a346
Reviewed-on: https://code.engineering.redhat.com/gerrit/152552
e7a346
Tested-by: RHGS Build Bot <nigelb@redhat.com>
e7a346
Reviewed-by: Sunil Kumar Heggodu Gopala Acharya <sheggodu@redhat.com>
e7a346
---
e7a346
 .../bug-1637802-arbiter-stale-data-heal-lock.t     | 44 ++++++++++++++++++++++
e7a346
 xlators/cluster/afr/src/afr-self-heal-data.c       |  2 +-
e7a346
 2 files changed, 45 insertions(+), 1 deletion(-)
e7a346
 create mode 100644 tests/bugs/replicate/bug-1637802-arbiter-stale-data-heal-lock.t
e7a346
e7a346
diff --git a/tests/bugs/replicate/bug-1637802-arbiter-stale-data-heal-lock.t b/tests/bugs/replicate/bug-1637802-arbiter-stale-data-heal-lock.t
e7a346
new file mode 100644
e7a346
index 0000000..91ed39b
e7a346
--- /dev/null
e7a346
+++ b/tests/bugs/replicate/bug-1637802-arbiter-stale-data-heal-lock.t
e7a346
@@ -0,0 +1,44 @@
e7a346
+#!/bin/bash
e7a346
+
e7a346
+. $(dirname $0)/../../include.rc
e7a346
+. $(dirname $0)/../../volume.rc
e7a346
+. $(dirname $0)/../../afr.rc
e7a346
+
e7a346
+cleanup;
e7a346
+
e7a346
+# Test to check that data self-heal does not leave any stale lock.
e7a346
+
e7a346
+TEST glusterd;
e7a346
+TEST pidof glusterd;
e7a346
+TEST $CLI volume create $V0 replica 3 arbiter 1 $H0:$B0/${V0}{0,1,2};
e7a346
+TEST $CLI volume start $V0;
e7a346
+EXPECT 'Started' volinfo_field $V0 'Status';
e7a346
+EXPECT_WITHIN $PROCESS_UP_TIMEOUT "1" brick_up_status $V0 $H0 $B0/${V0}0
e7a346
+EXPECT_WITHIN $PROCESS_UP_TIMEOUT "1" brick_up_status $V0 $H0 $B0/${V0}1
e7a346
+EXPECT_WITHIN $PROCESS_UP_TIMEOUT "1" brick_up_status $V0 $H0 $B0/${V0}2
e7a346
+TEST $GFS --volfile-id=/$V0 --volfile-server=$H0 $M0
e7a346
+EXPECT_WITHIN $PROCESS_UP_TIMEOUT "1" afr_child_up_status $V0 0
e7a346
+EXPECT_WITHIN $PROCESS_UP_TIMEOUT "1" afr_child_up_status $V0 1
e7a346
+EXPECT_WITHIN $PROCESS_UP_TIMEOUT "1" afr_child_up_status $V0 2
e7a346
+
e7a346
+# Create base entry in indices/xattrop
e7a346
+echo "Data" > $M0/FILE
e7a346
+
e7a346
+# Kill arbiter brick and write to FILE.
e7a346
+TEST kill_brick $V0 $H0 $B0/${V0}2
e7a346
+echo "arbiter down" >> $M0/FILE
e7a346
+EXPECT 2 get_pending_heal_count $V0
e7a346
+
e7a346
+# Bring it back up and let heal complete.
e7a346
+TEST $CLI volume start $V0 force
e7a346
+EXPECT_WITHIN $PROCESS_UP_TIMEOUT "1" brick_up_status $V0 $H0 $B0/${V0}2
e7a346
+EXPECT_WITHIN $CHILD_UP_TIMEOUT "1" afr_child_up_status_in_shd $V0 0
e7a346
+EXPECT_WITHIN $CHILD_UP_TIMEOUT "1" afr_child_up_status_in_shd $V0 1
e7a346
+EXPECT_WITHIN $CHILD_UP_TIMEOUT "1" afr_child_up_status_in_shd $V0 2
e7a346
+TEST $CLI volume heal $V0
e7a346
+EXPECT_WITHIN $HEAL_TIMEOUT "^0$" get_pending_heal_count $V0
e7a346
+
e7a346
+# write to the FILE must succeed.
e7a346
+echo "this must succeed" >> $M0/FILE
e7a346
+TEST [ $? -eq 0 ]
e7a346
+cleanup;
e7a346
diff --git a/xlators/cluster/afr/src/afr-self-heal-data.c b/xlators/cluster/afr/src/afr-self-heal-data.c
e7a346
index d3deb8f..2ac6e47 100644
e7a346
--- a/xlators/cluster/afr/src/afr-self-heal-data.c
e7a346
+++ b/xlators/cluster/afr/src/afr-self-heal-data.c
e7a346
@@ -765,7 +765,7 @@ restore_time:
e7a346
 	afr_selfheal_restore_time (frame, this, fd->inode, source,
e7a346
 					healed_sinks, locked_replies);
e7a346
 
e7a346
-        if (!is_arbiter_the_only_sink || !empty_file) {
e7a346
+        if (!is_arbiter_the_only_sink && !empty_file) {
e7a346
                 ret = afr_selfheal_inodelk (frame, this, fd->inode, this->name,
e7a346
                                             0, 0, data_lock);
e7a346
                 if (ret < priv->child_count) {
e7a346
-- 
e7a346
1.8.3.1
e7a346